<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Editor extends Model
{
    use HasFactory;

    protected $fillable = [
        'name',
        'company',
        'operating_system',
        'license',
        'created_at'
    ];

    /**
     * Returns a fully qualified resource URI for the editor's logo.
     *
     * @param string $value
     * @return string
     */
    public function getLogoAttribute($value)
    {
        return $value ? env('GOOGLE_CLOUD_STORAGE_API_URI') . 'images/editors/' . $value : null;
    }
}
